;ATXDRV start (copies rotation/movement data + dest. object)

;[obj]          = VTable
;[obj+4]        = n/a
;[obj+8]        = target instance + values

struct CAT107
       lpVTable 		dd	?
       refCount 		dd	?
       Instance 		dd	?
ends

align 16
;==========================================================
AT107MAIN:
;==========================================================

cmp [ATXDRV_ENABLED],TRUE
    jz NO_AT107_TRIGGER

	  mov [ATXDRV_CURROBJ],ecx

	  ;mov [ATXDRV_CURRENTRTMETHOD],UseATXDRV_RT_Type_0

	  cmp [ecx+atxdrv_base.Type],1
	      jnz AT107StartNotType1
	      mov [ATXDRV_CURRENTRTMETHOD],UseATXDRV_RT_Type_1
	      jmp NoATXDRV_CURRENT_COPY
	  AT107StartNotType1:

	  push edi
	  push esi
	  mov esi,ecx
	  mov edi,ATXDRV_CURRENT
	  mov ecx,(sizeof.atxdrv_inst_data)/4
	  rep movsd
	  pop esi
	  pop edi
	  NoATXDRV_CURRENT_COPY:

	  call DisableInGameMvtKeys

	  invoke GetTickCount
	  xor ecx,ecx
	  mov [ATXDRV_KeyLastTick],eax
	  mov [ATXDRV_MvtLastTick],eax
	  mov [ATXDRV_CurrVelocity],ecx
	  mov [ATXDRV_CurrRotSpeed],ecx

	  mov [ATXDRV_ENABLED],TRUE

NO_AT107_TRIGGER:
ret

align 16
;==========================================================
AT107_REINIT:
;==========================================================
     mov eax,[esp+4]
ret 4

align 16
;====================================================================
_AT107Init:	;Sample = destination object to control
;====================================================================
GETVALUE Frame,0
SETVALUE2 value_int		  ;(in eax)
     mov ebx,eax
     test ebx,ebx
	 ; jz ExitINAT

     mov edx,sizeof.atxdrv_inst_data
     cmp ebx,1
	 jnz ATXDRVNotType1_INIT
	 mov edx,sizeof.atxdrv_type1
     ATXDRVNotType1_INIT:

ALLOCAT edx
lea eax,[AT107]
mov [edi+atxdrv_base.VTable],eax
and [edi+atxdrv_base.Ref],DWORD 0
mov [edi+atxdrv_base.Type],ebx

GETVALUE Target,1
SETVALUE2 value_string			  ;(in eax)
     push eax
call GetInstanceFromString
mov [edi+atxdrv_base.Instance],eax
     pop eax

invoke GETTEMPINST_PROC,eax,0,1
mov [edi+atxdrv_base.TempInstance],eax	  ;for AT18 method only
add esp,12

;/* TEMP
    cmp DWORD [edi+atxdrv_base.Type],1
	jz DoType1TempSet

       mov ecx,edi
       mov [ecx+atxdrv_inst_data.GravityPush],10.000000
       mov [ecx+atxdrv_inst_data.KeyHandlerTick],40
       mov [ecx+atxdrv_inst_data.MvtHandlerTick],40
       mov [ecx+atxdrv_inst_data.RotPosOffset],2.000000
       mov [ecx+atxdrv_inst_data.FrontFastAccel],0.400000
       mov [ecx+atxdrv_inst_data.FrontSlowAccel],0.2000000
       mov [ecx+atxdrv_inst_data.BackSlowAccel],0.200000
       mov [ecx+atxdrv_inst_data.BackBrakeDecel],0.500000
       mov [ecx+atxdrv_inst_data.NaturalDecel],0.100000
       mov [ecx+atxdrv_inst_data.RotationAccelL],0.200000
       mov [ecx+atxdrv_inst_data.RotationAccelR],0.200000
       mov [ecx+atxdrv_inst_data.RotationDecel],0.250000
       mov [ecx+atxdrv_inst_data.MaxFastVelocity],3.000000
       mov [ecx+atxdrv_inst_data.MaxSlowVelocity],1.500000
       mov [ecx+atxdrv_inst_data.MaxBackVelocity],1.500000
       mov [ecx+atxdrv_inst_data.MaxTurnVelocityL],0.350000
       mov [ecx+atxdrv_inst_data.MaxTurnVelocityR],0.350000
       mov [ecx+atxdrv_inst_data.MinVelocityForTurn],0.20000

       fld [edi+atxdrv_inst_data.RotPosOffset]
       fchs
       fstp [edi+atxdrv_inst_data.RotPosOffset]

       fld [edi+atxdrv_inst_data.MaxBackVelocity]
       fchs
       fstp [edi+atxdrv_inst_data.MaxBackVelocity]

       fld [edi+atxdrv_inst_data.MaxTurnVelocityR]
       fchs
       fstp [edi+atxdrv_inst_data.MaxTurnVelocityR]

NoTempType1Set:
;*/

       jmp ExitINAT

DoType1TempSet:
       mov [edi+atxdrv_type1.Tick],50
       mov [edi+atxdrv_type1.FWDFast],30.00000
       mov [edi+atxdrv_type1.FWDSlow],15.0000000
       mov [edi+atxdrv_type1.BackSlow],-15.000000
       mov [edi+atxdrv_type1.BackBrake],-30.000000
       mov [edi+atxdrv_type1.LeftRight],0.200000
       mov [edi+atxdrv_type1.FastLimit],40.000000
       mov [edi+atxdrv_type1.SlowLimit],30.500000
       mov [edi+atxdrv_type1.BackLimit],-30.000000
       mov [edi+atxdrv_type1.LeftRightLimit],100.000000
       mov [edi+atxdrv_type1.MvtZAngleMul],0.000000
       mov [edi+atxdrv_type1.UseQuatMulInvert],FALSE
       jmp ExitINAT